#!/bin/bash

node=("NodeA" "NodeB" "NodeC" "NodeD" "NodeE" "NodeF" "NodeG" "NodeH")
noli=("A" "B" "C" "D" "E" "F" "G" "H")
#Create 8*Pool:Pool-A-1/Pool-B-1/Pool-C-1/Pool-D-1/Pool-E-1/Pool-F-1/Pool-G-1/Pool-H-1/
echo "Waiting for create 8*Pool"
for((i=0;i<8;i++))
do
   ms-cli ${node[$i]} "pool mgt create -n Pool-${noli[$i]}-1 -o CRAID-P"
done

#Create RAID: 8 *8* RAID10
echo "Waiting for create 64 RAID"
for((j=0;j<8;j++))
do
   ms-cli ${node[$j]} "raid mgt create -n RAID-${noli[$j]}-6-001 -p Pool-${noli[$j]}-1 -l RAID10 -d 6:1:1:1,6:1:1:2,6:1:1:3,6:1:1:4,6:1:1:7,6:1:1:8 -o CRAID-P -t SSD -i SAS -s 128KB -C 512"
   ms-cli ${node[$j]} "raid mgt create -n RAID-${noli[$j]}-6-002 -p Pool-${noli[$j]}-1 -l RAID10 -d 6:1:1:9,6:1:1:10,6:1:1:13,6:1:1:14,6:1:1:15,6:1:1:16 -o CRAID-P -t SSD -i SAS -s 128KB -C 512"
   ms-cli ${node[$j]} "raid mgt create -n RAID-${noli[$j]}-6-003 -p Pool-${noli[$j]}-1 -l RAID10 -d 6:1:1:19,6:1:1:20,6:1:1:21,6:1:1:22,10:1:1:19,10:1:1:20 -o CRAID-P -t SSD -i SAS -s 128KB -C 512"
   ms-cli ${node[$j]} "raid mgt create -n RAID-${noli[$j]}-9-001 -p Pool-${noli[$j]}-1 -l RAID10 -d 9:1:1:1,9:1:1:2,9:1:1:3,9:1:1:4,9:1:1:7,9:1:1:8 -o CRAID-P -t SSD -i SAS -s 128KB -C 512"
   ms-cli ${node[$j]} "raid mgt create -n RAID-${noli[$j]}-9-002 -p Pool-${noli[$j]}-1 -l RAID10 -d 9:1:1:9,9:1:1:10,9:1:1:13,9:1:1:14,9:1:1:15,9:1:1:16 -o CRAID-P -t SSD -i SAS -s 128KB -C 512"
   ms-cli ${node[$j]} "raid mgt create -n RAID-${noli[$j]}-9-003 -p Pool-${noli[$j]}-1 -l RAID10 -d 9:1:1:19,9:1:1:20,9:1:1:21,9:1:1:22,10:1:1:21,10:1:1:22 -o CRAID-P -t SSD -i SAS -s 128KB -C 512"
   ms-cli ${node[$j]} "raid mgt create -n RAID-${noli[$j]}-10-001 -p Pool-${noli[$j]}-1 -l RAID10 -d 10:1:1:5,10:1:1:6,10:1:1:7,10:1:1:8,10:1:1:9,10:1:1:10 -o CRAID-P -t SSD -i SAS -s 128KB -C 512"
   ms-cli ${node[$j]} "raid mgt create -n RAID-${noli[$j]}-10-002 -p Pool-${noli[$j]}-1 -l RAID10 -d 10:1:1:11,10:1:1:12,10:1:1:13,10:1:1:14,10:1:1:15,10:1:1:16 -o CRAID-P -t SSD -i SAS -s 128KB -C 512"

done

#Create LUN: 48*8 LUN
echo "Waiting for create LUN"
for((k=0;k<8;k++))
do
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-0001 -o SP1 -p Pool-${noli[$k]}-1 -s 370GB -R RAID-${noli[$k]}-6-001 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-0002 -o SP1 -p Pool-${noli[$k]}-1 -s 371GB -R RAID-${noli[$k]}-6-001 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-0003 -o SP1 -p Pool-${noli[$k]}-1 -s 372GB -R RAID-${noli[$k]}-6-001 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-0004 -o SP1 -p Pool-${noli[$k]}-1 -s 370GB -R RAID-${noli[$k]}-6-002 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-0005 -o SP1 -p Pool-${noli[$k]}-1 -s 371GB -R RAID-${noli[$k]}-6-002 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-0006 -o SP1 -p Pool-${noli[$k]}-1 -s 372GB -R RAID-${noli[$k]}-6-002 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-0007 -o SP1 -p Pool-${noli[$k]}-1 -s 370GB -R RAID-${noli[$k]}-6-003 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-0008 -o SP1 -p Pool-${noli[$k]}-1 -s 371GB -R RAID-${noli[$k]}-6-003 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-0009 -o SP1 -p Pool-${noli[$k]}-1 -s 372GB -R RAID-${noli[$k]}-6-003 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00010 -o SP1 -p Pool-${noli[$k]}-1 -s 370GB -R RAID-${noli[$k]}-9-001 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00011 -o SP1 -p Pool-${noli[$k]}-1 -s 371GB -R RAID-${noli[$k]}-9-001 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00012 -o SP1 -p Pool-${noli[$k]}-1 -s 372GB -R RAID-${noli[$k]}-9-001 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00013 -o SP1 -p Pool-${noli[$k]}-1 -s 370GB -R RAID-${noli[$k]}-9-002 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00014 -o SP1 -p Pool-${noli[$k]}-1 -s 371GB -R RAID-${noli[$k]}-9-002 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00015 -o SP1 -p Pool-${noli[$k]}-1 -s 372GB -R RAID-${noli[$k]}-9-002 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00016 -o SP1 -p Pool-${noli[$k]}-1 -s 370GB -R RAID-${noli[$k]}-9-003 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00017 -o SP1 -p Pool-${noli[$k]}-1 -s 371GB -R RAID-${noli[$k]}-9-003 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00018 -o SP1 -p Pool-${noli[$k]}-1 -s 372GB -R RAID-${noli[$k]}-9-003 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00019 -o SP1 -p Pool-${noli[$k]}-1 -s 370GB -R RAID-${noli[$k]}-10-001 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00020 -o SP1 -p Pool-${noli[$k]}-1 -s 371GB -R RAID-${noli[$k]}-10-001 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00021 -o SP1 -p Pool-${noli[$k]}-1 -s 372GB -R RAID-${noli[$k]}-10-001 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00022 -o SP1 -p Pool-${noli[$k]}-1 -s 370GB -R RAID-${noli[$k]}-10-002 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00023 -o SP1 -p Pool-${noli[$k]}-1 -s 371GB -R RAID-${noli[$k]}-10-002 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00024 -o SP1 -p Pool-${noli[$k]}-1 -s 372GB -R RAID-${noli[$k]}-10-002 -r disable -w disable"
   
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00025 -o SP2 -p Pool-${noli[$k]}-1 -s 370GB -R RAID-${noli[$k]}-6-001 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00026 -o SP2 -p Pool-${noli[$k]}-1 -s 371GB -R RAID-${noli[$k]}-6-001 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00027 -o SP2 -p Pool-${noli[$k]}-1 -s 372GB -R RAID-${noli[$k]}-6-001 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00028 -o SP2 -p Pool-${noli[$k]}-1 -s 370GB -R RAID-${noli[$k]}-6-002 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00029 -o SP2 -p Pool-${noli[$k]}-1 -s 371GB -R RAID-${noli[$k]}-6-002 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00030 -o SP2 -p Pool-${noli[$k]}-1 -s 372GB -R RAID-${noli[$k]}-6-002 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00031 -o SP2 -p Pool-${noli[$k]}-1 -s 370GB -R RAID-${noli[$k]}-6-003 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00032 -o SP2 -p Pool-${noli[$k]}-1 -s 371GB -R RAID-${noli[$k]}-6-003 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00033 -o SP2 -p Pool-${noli[$k]}-1 -s 372GB -R RAID-${noli[$k]}-6-003 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00034 -o SP2 -p Pool-${noli[$k]}-1 -s 370GB -R RAID-${noli[$k]}-9-001 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00035 -o SP2 -p Pool-${noli[$k]}-1 -s 371GB -R RAID-${noli[$k]}-9-001 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00036 -o SP2 -p Pool-${noli[$k]}-1 -s 372GB -R RAID-${noli[$k]}-9-001 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00037 -o SP2 -p Pool-${noli[$k]}-1 -s 370GB -R RAID-${noli[$k]}-9-002 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00038 -o SP2 -p Pool-${noli[$k]}-1 -s 371GB -R RAID-${noli[$k]}-9-002 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00039 -o SP2 -p Pool-${noli[$k]}-1 -s 372GB -R RAID-${noli[$k]}-9-002 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00040 -o SP2 -p Pool-${noli[$k]}-1 -s 370GB -R RAID-${noli[$k]}-9-003 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00041 -o SP2 -p Pool-${noli[$k]}-1 -s 371GB -R RAID-${noli[$k]}-9-003 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00042 -o SP2 -p Pool-${noli[$k]}-1 -s 372GB -R RAID-${noli[$k]}-9-003 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00043 -o SP2 -p Pool-${noli[$k]}-1 -s 370GB -R RAID-${noli[$k]}-10-001 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00044 -o SP2 -p Pool-${noli[$k]}-1 -s 371GB -R RAID-${noli[$k]}-10-001 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00045 -o SP2 -p Pool-${noli[$k]}-1 -s 372GB -R RAID-${noli[$k]}-10-001 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00046 -o SP2 -p Pool-${noli[$k]}-1 -s 370GB -R RAID-${noli[$k]}-10-002 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00047 -o SP2 -p Pool-${noli[$k]}-1 -s 371GB -R RAID-${noli[$k]}-10-002 -r disable -w disable"
   ms-cli ${node[$k]} "lun mgt createthicklun -n LUN-${noli[$k]}-00048 -o SP2 -p Pool-${noli[$k]}-1 -s 372GB -R RAID-${noli[$k]}-10-002 -r disable -w disable"

done

#create itl
for((k1=0;k1<8;k1++))
do
	targetvalue=(`ms-cli ${node[$k1]} "client target queryportlist" |grep  'fc port' |sed -e 's/^.*> //g ; s/fc port-./FC-Target/g'`)
	initiatorvalue=(`ms-cli ${node[$k1]} "client target queryportlist" |grep  'initiator\[0\]' |sed  's/^initiator\[0\]        : //g'`)
	targetna=(`ms-cli ${node[$k1]} "client target queryportlist" |grep  'fc port' |sed -e 's/^.*> //g ; s/fc port-./FC/g'`)
	targetport=(`ms-cli ${node[$k1]} "client target queryportlist "|grep  'fc port' |sed -e 's/^.*> //g ; s/fc port-..//g'`)
	itll=${#initiatorvalue[*]}
	for((k2=0;k2<$itll;k2++))
	do
		#Create client
		echo "Waiting for create client"
		ms-cli ${node[$k1]} "client mgt create -n ${targetport[$k2]}"
		#Create initiator
		echo "Waiting for create initiator"
		ms-cli ${node[$k1]} "client initiator modifyos -w ${initiatorvalue[$k2]} -o Linux"
		ms-cli ${node[$k1]} "client initiator modifyalias -w ${initiatorvalue[$k2]} -a ${targetport[$k2]}"
		#Add Target: 16
		echo "Waiting for add Target"
		ms-cli ${node[$k1]} "client target create -t fc -p ${targetna[$k2]}"
		#map-client
		echo "Waiting for map-client"
		ms-cli ${node[$k1]} "client mgt mapinitiator -c ${targetport[$k2]} -i ${initiatorvalue[$k2]}"
		#map-target
		echo "Waiting for map-target"
		ms-cli ${node[$k1]} "client itl maptarget -i ${initiatorvalue[$k2]} -t ${targetvalue[$k2]}"
		#map LUN 
		echo "Waiting for map LUN"
		if [[ $k2 -lt 20 ]]
		then
			for((k3=1;k3<25;k3++))
			do
				ms-cli ${node[$k1]} "client itl maplun -i ${initiatorvalue[$k2]} -t ${targetvalue[$k2]} -l LUN-${noli[$k1]}-000$k3"
			done
		else
			for((k3=25;k3<49;k3++))
			do
			  ms-cli ${node[$k1]} "client itl maplun -i ${initiatorvalue[$k2]} -t ${targetvalue[$k2]} -l LUN-${noli[$k1]}-000$k3"
			done
		fi
	done
done


echo "complete "
exit 0
